/* GSI - general sound interface
 *
 * gsimixer.h
 *
 * 1996 - 2000 by W.H.Scholten
 *
 * This file is released to the public domain.
 */


#ifndef _GSI__gsimixer__gsimixer_h
#define _GSI__gsimixer__gsimixer_h


#include <gsi/mixer_data.h>



#define GSIMIXER_HW_S struct gsimixer_device *hw, struct gsimixer_devicedata *hw_status
typedef struct gsimixer_devicedata {
	int  dev; /* remove? */
	int  fd;
	int  fd_ct;
} gsimixer_devicedata_t;

typedef struct gsimixer_device {
	char *device; /* the device to open, e.g. /dev/mixer */
	char id[32]; /* e.g. mixer/(OSS) */

	int  (*init) (GSIMIXER_HW_S);
	int  (*close) (GSIMIXER_HW_S);
	int  (*set_volume) (GSIMIXER_HW_S, int dev_type, int devno, int vol);
} gsimixer_device_t;


extern int  gsimixer_ok;
extern char *gsimixer_device;

extern gsimixer_device_t *mixer_devices;
extern int  gsimixer_num_devices [ GSIMIXER_NUM_DEVICE_TYPES ];

/* extern int  gsimixer_volume [ _RECORD_DEVICE_OFFSET + GSIMIXER_NUM_DEVICE_TYPES ]; */
extern int  *gsimixer_volume [ _RECORD_DEVICE_OFFSET + GSIMIXER_NUM_DEVICE_TYPES ];

/* Mixer volumes are 0-256 */

int  gsimixer_init (void);
int  gsimixer_close (void);

int  gsimixer_set_device_volume (int device_type, int device_no, int vol);
int  gsimixer_get_device_volume (int device_type, int device_no);

int  gsimixer_mute (void);
int  gsimixer_unmute (void);
int  gsimixer_set_balance (int new_balance);


/*---------------------------------------------------------------------------*
 *      Where to send error messages, if not set (or set to NULL) then stderr
 *      is used.
 *---------------------------------------------------------------------------*/
void gsimixer_log_set_handler (void (*handler) (int msg_type, char *msg));

#endif /* _GSI__gsimixer__gsimixer_h */
